// Ionic Starter App

angular.module('underscore', [])
.factory('_', function() {
  return window._; // assumes underscore has already been loaded on the page
});

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('your_app_name', [
  'ionic',
  'angularMoment',
  'your_app_name.controllers',
  'your_app_name.directives',
  'your_app_name.filters',
  'your_app_name.services',
  'your_app_name.factories',
  'your_app_name.config',
  'your_app_name.views',
  'underscore',
  'ngMap',
  'ngResource',
  'ngCordova',
  'slugifier',
  'ionic.contrib.ui.tinderCards',
  'youtube-embed',
  'firebase'
])

.run(function($ionicPlatform, PushNotificationsService, $rootScope, $ionicConfig, $timeout, userFactory, $cordovaBadge) {

  $ionicPlatform.on("deviceready", function(){
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }

    //PushNotificationsService.register();


// ---------------INICIO ON NOTIFICATION
	if (window.cordova) {
		console.log('init on Notification device ready');
    
    $cordovaBadge.clear().then(function() {}, function(err) {});
    window.cordova.plugins.notification.badge.clear();
    userFactory.initNotification();
		console.log('end on Notification');
	}
  // ---------------FIN ON NOTIFICATION
  
  });

  // This fixes transitions for transparent background views
  $rootScope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams){
    if(toState.name.indexOf('auth.walkthrough') > -1)
    {
      // set transitions to android to avoid weird visual effect in the walkthrough transitions
      $timeout(function(){
        $ionicConfig.views.transition('android');
        $ionicConfig.views.swipeBackEnabled(false);
      	console.log("setting transition to android and disabling swipe back");
      }, 0);
    }
  });
  $rootScope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState, fromParams){
    if(toState.name.indexOf('app.feeds-categories') > -1)
    {
      // Restore platform default transition. We are just hardcoding android transitions to auth views.
      $ionicConfig.views.transition('platform');
      // If it's ios, then enable swipe back again
      if(ionic.Platform.isIOS())
      {
        $ionicConfig.views.swipeBackEnabled(true);
      }
    	console.log("enabling swipe back and restoring transition to platform default", $ionicConfig.views.transition());
    }
  });

  $ionicPlatform.on("resume", function(){
   // PushNotificationsService.register();
   // ---------------INICIO ON NOTIFICATION
	if (window.cordova) {
		console.log('init on Notification resumen');
    
    $cordovaBadge.clear().then(function() {}, function(err) {});
    window.cordova.plugins.notification.badge.clear();
    userFactory.initNotification();
		console.log('end on Notification resumen');
	}
  // ---------------FIN ON NOTIFICATION
  });

})


.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
  $stateProvider

  //INTRO
  .state('auth', {
    url: "/auth",
    cache: true,
    templateUrl: "views/auth/auth.html",
    abstract: true,
    controller: 'AuthCtrl'
  })

  .state('auth.walkthrough', {
    url: '/walkthrough',
    cache: false,
    templateUrl: "views/auth/walkthrough.html",
    controller: 'SignupCtrl'
  })

  .state('auth.login', {
    url: '/login',
    cache: true,
    templateUrl: "views/auth/login.html",
    controller: 'LoginCtrl'
  })

  .state('auth.signup', {
    url: '/signup',
    cache: true,
    templateUrl: "views/auth/signup.html",
    controller: 'SignupCtrl'
  })

  .state('auth.forgot-password', {
    url: "/forgot-password",
    cache: true,
    templateUrl: "views/auth/forgot-password.html",
    controller: 'ForgotPasswordCtrl'
  })

  .state('app', {
    url: "/app",
    abstract: true,
    cache: true,
    templateUrl: "views/app/side-menu.html",
    controller: 'AppCtrl'
  })

  //MISCELLANEOUS
  .state('app.miscellaneous', {
    url: "/miscellaneous",
    views: {
      'menuContent': {
        templateUrl: "views/app/miscellaneous/miscellaneous.html"
      }
    }
  })

  .state('app.maps', {
    url: "/miscellaneous/maps",
    views: {
      'menuContent': {
        templateUrl: "views/app/miscellaneous/maps.html",
        controller: 'MapsCtrl'
      }
    }
  })

  .state('app.image-picker', {
    url: "/miscellaneous/image-picker",
    views: {
      'menuContent': {
        templateUrl: "views/app/miscellaneous/image-picker.html",
        controller: 'ImagePickerCtrl'
      }
    }
  })

  //LAYOUTS
  .state('app.layouts', {
    url: "/layouts",
    views: {
      'menuContent': {
        templateUrl: "views/app/layouts/layouts.html"
      }
    }
  })

  .state('app.tinder-cards', {
    url: "/layouts/tinder-cards",
    views: {
      'menuContent': {
        templateUrl: "views/app/layouts/tinder-cards.html",
        controller: 'TinderCardsCtrl'
      }
    }
  })

  .state('app.slider', {
    url: "/layouts/slider",
    views: {
      'menuContent': {
        templateUrl: "views/app/layouts/slider.html"
      }
    }
  })

  //FEED
  .state('app.menu', {
    url: "/menu/:idsitio/:condoId",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/feeds/feeds-categories.html",
        controller: 'menuSitioCtrl'
      }
    }
  })

  .state('app.category-feeds', {
    url: "/category-feeds/:categoryId/:idsitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/feeds/category-feeds.html",
        controller: 'CategoryFeedsCtrl'
      }
    }
  })

  .state('app.category-feeds2', {
    url: "/category-feeds/:categoryId/:idsitio/:condoId",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/feeds/category-feeds.html",
        controller: 'CategoryFeedsCtrl'
      }
    }
  })

  .state('app.feed-entries', {
    url: "/feed-entries/:categoryId/:sourceId",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/feeds/feed-entries.html",
        controller: 'FeedEntriesCtrl'
      }
    }
  })
  .state('app.verificacion-paquetes', {
    url: "/casillero/verificacionPaquetes",
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/verificacionPaquetes.html",
        controller: 'verificaionPaquetesCtrl'
      }
    }
  })
  .state('app.listaVehiculos', {
    url: "/parqueo/listaVehiculos",
    views: {
      'menuContent': {
        templateUrl: "views/app/parqueo/listaVehiculos.html",
        controller: 'verificaionPaquetesCtrl'
      }
    }
  })

  //WORDPRESS
  .state('app.wordpress', {
    url: "/wordpress",
    views: {
      'menuContent': {
        templateUrl: "views/app/wordpress/wordpress.html",
        controller: 'WordpressCtrl'
      }
    }
  })

  .state('app.post', {
    url: "/wordpress/:postId",
    views: {
      'menuContent': {
        templateUrl: "views/app/wordpress/wordpress_post.html",
        controller: 'WordpressPostCtrl'
      }
    },
    resolve: {
      post_data: function(PostService, $ionicLoading, $stateParams) {
        $ionicLoading.show({
      		template: 'Loading post ...'
      	});

        var postId = $stateParams.postId;
        return PostService.getPost(postId);
      }
    }
  })

  //OTHERS
   .state('app.entregarPaquete', {
    url: "/entregarPaquete/:codigo",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/listaPaquetes.html",
        controller: 'entregarPaqueteCtrl'
      }
    }
  })  
  .state('app.registroExitoso', {
    url: "/registroExitoso",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/registroExitoso.html",
        controller: 'SettingsCtrl'
      }
    }
  }) 
  .state('app.registrarPaquete', {
    url: "/registrarPaquete",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/registrarPaquete.html",
        controller: 'registrarPaqueteCtrl'
      }
    }
  }) 
  .state('app.listarResidentes', {
    url: "/listaResidentes/:referencia1/:referencia2",
    cache: true,
    params:{referencia1:null , referencia2:null},
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/listarResidentes.html",
        controller: 'listarResidentesCtrl'
      }
    }
  })
  .state('app.registrarPaqueteFinal', {
    url: "/registrarPaqueteFinal/:referencia1/:referencia2",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/registrarPaqueteFinal.html",
        controller: 'registrarPaqueteFinalCtrl'
      }
    }
  }) 
  .state('app.registroMasivo', {
    url: "/registroMasivo",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/registroMasivo.html",
        controller: 'registroMasivoCtrl'
      }
    }
  })
 .state('app.historialCasillero', {
    url: "/historialCasillero/:idsitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/historialCasillero.html",
        controller: 'historialCasilleroCtrl'
      }
    }
  })
  .state('app.misVehiculos', {
    url: "/misVehiculos/:idsitio",
    views: {
      'menuContent': {
        templateUrl: "views/app/parqueo/misVehiculos.html",
        controller: 'misVehiculosCtrl'
      }
    }
  })
   .state('app.codigoMisVehiculos', {
    url: "/codigoMisVehiculos/:idsitio/:idvehiculo",
    views: {
      'menuContent': {
        templateUrl: "views/app/parqueo/codigoMisVehiculos.html",
        controller: 'codigoMisVehiculosCtrl'
      }
    }
  })
   .state('app.adicionarVehiculo', {
    url: "/adicionarVehiculo/:idsitio",
    views: {
      'menuContent': {
        templateUrl: "views/app/parqueo/adicionarVehiculo.html",
        controller: 'adicionarVehiculoCtrl'
      }
    }
  })
  .state('app.validarCodigoPaquete', {
    url: "/validarCodigoPaquete",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/codigo.html",
        controller: 'validarCodigoCtrl'
      }
    }
  })
   .state('app.residenteParqueo', {
    url: "/residenteParqueo",
    views: {
      'menuContent': {
        templateUrl: "views/app/parqueo/residenteParqueo.html",
        controller: 'residenteParqueoCrtl'
      }
    }
  })
   .state('app.autorizacionParqueo', {
    url: "/autorizacionParqueo/:codigo",
    views: {
      'menuContent': {
        templateUrl: "views/app/parqueo/autorizacionParqueo.html",
        controller: 'codigoParqueoCrtl'
      }
    }
  })
  .state('app.visitanteParqueo', {
    url: "/visitanteParqueo/:idsitio",
    views: {
      'menuContent': {
        templateUrl: "views/app/parqueo/visitantes/visitanteParqueo.html",
        controller: 'visitanteParqueoCtrl'
      }
    }
  })
  .state('app.favoritos', {
    url: "/favoritos",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/favoritos.html",
        cache: true,
        controller: 'favoritosCtrl'
        
      }
    }
  }).state('app.recordatorios', {
    url: "/recordatorios/:view",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/recordatorios.html",
        cache: true,
        controller: 'recordatoriosCtrl'
      }
    }   
  }).state('app.notificaciones', {
    url: "/notificaciones",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/notificaciones.html",
        controller: 'notificacionesCtrl'
      }
    }   
  }).state('app.autorizacionVisitanteParqueo', {
    url: "/visitanteParqueo/autorizacionParqueo/:codigo",
    views: {
      'menuContent': {
        templateUrl: "views/app/parqueo/visitantes/autorizacionParqueo.html",
        controller: 'codigoParqueoVisitanteCrtl'
      }
    }
  })
  .state('app.buscarSitio', {
    url: "/buscarSitio/:opcion",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/buscarSitio.html",
        controller: 'buscarSitioCtrl'
      }
    }
  }) 
  .state('app.buscarMensaje', {
    url: "/buscarMensaje/:referencia1/:referencia2",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/buscarMensaje.html",
        controller: 'buscarMensajeCtrl'
      }
    }
  }) 
  .state('app.dejarMensaje', {
    url: "/dejarMensaje/:sourceId/:idsitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/dejarMensaje.html",
        controller: 'dejarMensajeCtrl'
      }
    }
  }) 
  .state('app.compartirSitio', {
    url: "/compartirSitio/:idsitio/:condoId",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/compartirSitio.html",
        controller: 'compartirSitioCtrl'
      }
    }
  }) 
  .state('app.citofono', {
    url: "/servicio/:idsitio/:condoId",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/servicio.html",
        controller: 'servicioCtrl'
      }
    }
  }) 
  .state('app.residentes', {
    url: "/residentes/:idsitio/:condoId",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/residentes.html",
        controller: 'residentesCtrl'
      }
    }
  }) 
  .state('app.historialMensaje', {
    url: "/historialMensaje/:idsitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/historialMensajes.html",
        controller: 'historialMensajeCtrl'
      }
    }
  }) 
  .state('app.historialCasilleroEnviados', {
    url: "/MensajesEnviados/:idsitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/MensajesEnviados.html",
        controller: 'MensajesEnviadosCtrl'
      }
    }
  })
  .state('app.historialCasilleroEnviadosAdmin', {
    url: "/MensajesEnviadosAdmin/:idsitio/:condoId",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/MensajesEnviadosAdmin.html",
        controller: 'MensajesEnviadosAdminCtrl'
      }
    }
  }) 
  .state('app.chatMensaje', {
    url: "/chatMensaje/:referencia1/:referencia2",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/mensajes/chatMensaje.html",
        controller: 'chatMensajeCtrl'
      }
    }
  }) 
  
  .state('app.settings', {
    url: "/settings",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/settings.html",
        controller: 'SettingsCtrl'
      }
    }
  })
  //------------------------------------------
  //-----------STATE PARA RESIDENTES----------
  //------------------------------------------
.state('app.misSitios', {
    url: "/misSitios",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/feeds/misSitios.html",
        controller: 'misSitiosCtrl'
      }
    }
  })
  .state('app.adicionarSitio', {
    url: "/adicionarSitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/feeds/adicionarSitio.html",
        controller: 'adicionarSitioCtrl'
      }
    }
  })
  .state('app.descripcionSitio', {
    url: "/descripcionSitio/:codigoSitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/feeds/descripcionSitio.html",
        controller: 'descripcionSitioCtrl'
      }
    }
  })
  .state('app.registroSitio', {
    url: "/registroSitio/:codigoSitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/feeds/registroSitio.html",
        controller: 'descripcionSitioCtrl'
      }
    }
  })
   .state('app.reclamarPaquete', {
    url: "/reclamarPaquete/:idsitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/listaPaquetes.html",
        controller: 'reclamarPaqueteCtrl'
      }
    }
  })  
.state('app.reclamarPaqueteCodigo', {
    url: "/reclamarPaqueteCodigo/:idsitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/reclamarPaqueteCodigo.html",
        controller: 'reclamarPaqueteCodigoCtrl'
      }
    }
  })
  .state('app.listaPaquetesConfirmacion', {
    url: "/listaPaquetesConfirmacion/:idsitio",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/casillero/listaPaquetesConfirmacion.html",
        controller: 'reclamarPaqueteCodigoCtrl'
      }
    }
  })



  
  .state('app.forms', {
    url: "/forms",
    views: {
      'menuContent': {
        templateUrl: "views/app/forms.html"
      }
    }
  })

  .state('app.profile', {
    url: "/profile",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/profile.html",
        controller: "ProfileCtrl"
      }
    }
  })
  .state('app.about', {
    url: "/about",
    cache: true,
    views: {
      'menuContent': {
        templateUrl: "views/app/about.html",
        controller: "ProfileCtrl"
      }
    }
  })

  .state('app.bookmarks', {
    url: "/bookmarks",
    views: {
      'menuContent': {
        templateUrl: "views/app/bookmarks.html",
        controller: 'BookMarksCtrl'
      }
    }
  })

;

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/auth/walkthrough');
});
